program Double_Linked_List;
uses crt;
type
    PData=^TData;
    TData=record
                info:integer;
                next:PData;
                prev:PData;
          end;
var
   awal,akhir:PData;

procedure ciptakan_linked_list(var awal,akhir:PData);
begin
     awal:=nil;
     akhir:=nil;
end;

procedure sisip_depan(data:integer;var awal,akhir:PData);
var
   baru:PData;
begin
     new(baru);
     baru^.info:=data;
     baru^.next:=nil;
     baru^.prev:=nil;

     if awal=nil then
     begin
          awal:=baru;
          akhir:=baru;
     end
     else
     begin
          baru^.next:=awal;
          awal^.prev:=baru;
          awal:=baru;
     end;
end;
procedure sisip_belakang(data:integer;var awal,akhir:PData);
var
   baru:PData;
begin
     new(baru);
     baru^.info:=data;
     baru^.next:=nil;
     baru^.prev:=nil;

     if awal=nil then
     begin
          awal:=baru;
          akhir:=baru;
     end
     else
     begin
          akhir^.next:=baru;
          baru^.prev:=akhir;
          akhir:=baru;
     end;
end;
procedure sisip_tengah(data:integer;var awal,akhir:PData);
var
   baru,bantu:PData;
   posisi_sisip:integer;
begin
     if awal=nil then
     begin
          sisip_depan(data,awal,akhir);
     end
     else
     begin
          write('Data "',data,'" mau disisip sebelum data berapa ? ');
          readln(posisi_sisip);

          bantu:=awal;
          while (bantu^.info<>posisi_sisip)and
                (bantu<>akhir) do
                bantu:=bantu^.next;

          if bantu=awal then
             sisip_depan(data,awal,akhir)
          else
          if bantu^.info=posisi_sisip then
          begin

               new(baru);
               baru^.info:=data;
               baru^.next:=nil;
               baru^.prev:=nil;

               baru^.next:=bantu;
               baru^.prev:=bantu^.prev;
               bantu^.prev^.next:=baru;
               bantu^.prev:=baru;
          end
          else
              writeln('Data posisi sisip tidak ditemukan');
     end;
end;
procedure tampil_linked_list(awal,akhir:PData);
var
   bantu:PData;
begin
     write('Data  : ');
     if awal=nil then
        write('<DATANYA KOSONG>')
     else
     begin
          bantu:=awal;
          while bantu<>nil do
          begin
               write(bantu^.info:4);
               bantu:=bantu^.next;
          end;

     end;
     writeln;
end;
procedure tampil_linked_list_dari_belakang(awal,akhir:PData);
var
   bantu:PData;
begin
     write('Data  : ');
     if awal=nil then
        write('<DATANYA KOSONG>')
     else
     begin
          bantu:=akhir;
          while bantu<>nil do
          begin
               write(bantu^.info:4);
               bantu:=bantu^.prev;
          end;
          writeln;
     end;
end;
procedure hapus_depan(var data_yang_dihapus:integer; var awal,akhir:PData);
var
   bantu:PData;
begin
     // diasumsikan bahwa data pasti ada (tidak kosong)
     if awal=akhir then
     begin
          data_yang_dihapus:=awal^.info;
          dispose(awal);
          awal:=nil;
          akhir:=nil;
     end
     else
     if awal<>akhir then
     begin
          data_yang_dihapus:=awal^.info;
          bantu:=awal;
          awal:=awal^.next;
          dispose(bantu);
          awal^.prev:=nil;
     end;
end;
procedure hapus_belakang(var data_yang_dihapus:integer; var awal,akhir:PData);
var
   bantu:PData;
begin
     // diasumsikan bahwa data pasti ada (tidak kosong)
     if awal=akhir then
     begin
          hapus_depan(data_yang_dihapus,awal,akhir);
     end
     else
     if awal<>akhir then
     begin
         data_yang_dihapus:=akhir^.info;
         akhir:=akhir^.prev;
         dispose(akhir^.next);
         akhir^.next:=nil;
     end;
end;
procedure hapus_tengah(var data_yang_dihapus:integer; var awal,akhir:PData);
var
   bantu:PData;
   dihapus:integer;
begin
     // diasumsikan bahwa data pasti ada (tidak kosong)
     if awal=akhir then
     begin
          hapus_depan(data_yang_dihapus,awal,akhir);
     end
     else
     if awal<>akhir then
     begin
          write('Data yang akan dihapus ? ');readln(dihapus);
          // cari simpul yang dihapus
          bantu:=awal;
          while (bantu^.info<>dihapus)and
                (bantu<>akhir) do
                bantu:=bantu^.next;

          if bantu=awal then
          begin
               hapus_depan(data_yang_dihapus,awal,akhir)
          end
          else
          if (bantu=akhir)and(bantu^.info=dihapus) then
          begin
               hapus_belakang(data_yang_dihapus,awal,akhir);
          end
          else
          if bantu^.info=dihapus then
          begin
               data_yang_dihapus:=bantu^.info;
               bantu^.prev^.next:=bantu^.next;
               bantu^.next^.prev:=bantu^.prev;
               dispose(bantu);
          end
          else
              writeln('Data yang dihapus tidak ditemukan');
      end;
end;
procedure hancurkan_linked_list(var awal,akhir:PData);
var
   data:integer;
begin
     while awal<>nil do
           hapus_depan(data,awal,akhir);
end;

var
   i:integer;
   data:integer;
   pilihan:byte;
begin
     ciptakan_linked_list(awal,akhir);
     repeat
           clrscr;
           writeln('Menu Pilihan ');
           writeln('-----------------------------------');
           writeln('1. Tambah Depan');
           writeln('2. Tambah Tengah');
           writeln('3. Tambah Belakang');
           writeln('4. Tampilkan data');
           writeln('5. Hapus Depan');
           writeln('6. Hapus Tengah');
           writeln('7. Hapus Belakang');
           writeln('0. Keluar');
           writeln('-----------------------------------');
           write('Pilihan ? ');readln(pilihan);
           if pilihan in [1,2,3] then
           begin
                write('Data yang akan ditambahkan : ');readln(data);
                if pilihan=1 then
                   sisip_depan(data,awal,akhir)
                else
                if pilihan=2 then
                   sisip_tengah(data,awal,akhir)
                else
                    sisip_belakang(data,awal,akhir);
                writeln('Kondisi data setelah penyisipan.');
                tampil_linked_list(awal,akhir);
           end
           else
           if pilihan=4 then
              tampil_linked_list(awal,akhir)
           else
           if pilihan in [5,6,7] then
           begin
             if awal<>nil then
             begin
                if pilihan=5 then
                   hapus_depan(data,awal,akhir)
                else
                if pilihan=6 then
                   hapus_tengah(data,awal,akhir)
                else
                    hapus_belakang(data,awal,akhir);

                writeln('Data yang dihapus adalah ',data);
                writeln('Kondisi data setelah penghapusan.');
                tampil_linked_list(awal,akhir);
            end
            else
                writeln('Data kosong. Penghapusan tidak dilakukan');
           end;
           writeln('Proses selesai. Tekan sembarang tombol');readkey;

     until pilihan=0;
     hancurkan_linked_list(awal,akhir);
end.
